// vim:syntax=javascript

class Menu extends MovieClip {
    var key_listener:Object;
    var doReset:Function;
    var doSelectLevel:Function;
    var doFinished:Function;
    var min_level:Number;
    var max_level:Number;
    var level_selected:Number;

    function onLoad() {
        var static_this = this;

        _alpha = 90;

        /*
        beginFill(0x000000);
        lineStyle(10, 0x000000, 90);
        moveTo(100,70);
        lineTo(300,70);
        lineTo(300,270);
        lineTo(100,270);
        lineTo(100,70);
        endFill();
        */

        var corner = 15;
        var menu_x = 75;
        var menu_y = 70;
        var menu_width = 250;
        var menu_height = 80;

        RoundRect.roundRect(this, menu_x, menu_y, menu_width, menu_height, corner);

        /*
        // Title
        VeraText.create(this, "menu_title_txt", "MENU", 30, menu_x, menu_y,
            menu_width, 35);
        */

        // Reset
        var addMenuItem =
        function (name:String, msg:String, y:Number, width:Number, callback:Function) {
            static_this.createEmptyMovieClip(name+"_mc", static_this.getNextHighestDepth());
            var mc:MovieClip = static_this[name+"_mc"];
            VeraText.create(mc, name+"_txt", msg, 20, 0, 0,
                width, 30);
            var txt:TextField = mc[name+"_txt"];
            mc._x = menu_x;
            mc._y = menu_y+10+y*30;
            mc.onRollOver = function () {
                var tfmt:TextFormat = txt.getTextFormat();
                tfmt.color = 0xFF0000;
                txt.setTextFormat(tfmt);
            };
            mc.onRollOut = function () {
                var tfmt:TextFormat = txt.getTextFormat();
                tfmt.color = 0xFFFFFF;
                txt.setTextFormat(tfmt);
            };
            mc.onPress = function () {
                delete this.onRollOver;
                delete this.onRollOut;
                delete this.onPress;
                static_this.removeMovieClip();
                callback();
             };
        };

        addMenuItem("menu_reset", "Reset Level", 0, menu_width, function () {static_this.doReset();});
        addMenuItem("menu_levelsel", "Go To Level", 1, 140, function () {static_this.doSelectLevel(static_this.level_selected)});
        this["menu_levelsel_mc"]._x = menu_x+(menu_width-140-90)/2;

        // Level select controls
        {
            createEmptyMovieClip("prevlev_mc", getNextHighestDepth());
            createEmptyMovieClip("nextlev_mc", getNextHighestDepth());
            var prevlev_mc:MovieClip = this["prevlev_mc"];
            var selected_txt:TextField = VeraText.create(this, "level_selected_text",
                level_selected.toString(), 20, 0, 0, 45, 30);
            var nextlev_mc:MovieClip = this["nextlev_mc"];

            var drawArrow = function (mc:MovieClip, left:Boolean, color:Number) {
                with (mc) {
                    clear();
                    beginFill(color);
                    lineStyle(1,color);
                    moveTo(left?15:0,0);
                    lineTo(left?0:15,15);
                    lineTo(left?15:0,30);
                    endFill();
                }
            }

            drawArrow(prevlev_mc, true, 0xFFFFFF);

            drawArrow(nextlev_mc, false, 0xFFFFFF);

            prevlev_mc._x = this["menu_levelsel_mc"]._x+this["menu_levelsel_mc"]._width;
            prevlev_mc._y = menu_y+10+1*30;
            selected_txt._x = prevlev_mc._x + 20;
            selected_txt._y = prevlev_mc._y;
            nextlev_mc._x = selected_txt._x + 50;
            nextlev_mc._y = prevlev_mc._y;

            prevlev_mc.onPress = function () {
                with (static_this) {
                    if (level_selected > min_level) {
                        level_selected --;
                        selected_txt.text = level_selected.toString();
                    }
                }
            }
            nextlev_mc.onPress = function () {
                with (static_this) {
                    if (level_selected < max_level) {
                        level_selected ++;
                        selected_txt.text = level_selected.toString();
                    }
                }
            }

            prevlev_mc.onRollOver = function () {
                drawArrow(prevlev_mc, true, 0xFF0000);
            }
            prevlev_mc.onRollOut = function () {
                drawArrow(prevlev_mc, true, 0xFFFFFF);
            }
            nextlev_mc.onRollOver = function () {
                drawArrow(nextlev_mc, false, 0xFF0000);
            }
            nextlev_mc.onRollOut = function () {
                drawArrow(nextlev_mc, false, 0xFFFFFF);
            }
        }

        key_listener = {
            onKeyDown : function () {
                var k:Number = Key.getCode();

                if (k == Key.ESCAPE) {
                    static_this.removeMovieClip();
                }
            }
        };

        Key.addListener(key_listener);
    }

    function onUnload() {
        trace("Menu.onUnload");
        Key.removeListener(key_listener);
        doFinished();
    }
};
